"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from typing import Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


class GenericVisualizePortfolioChain(str, Enum):
    r"""The chain to use."""

    BASE_MAINNET = "base:mainnet"
    ETHEREUM_MAINNET = "ethereum:mainnet"
    ARBITRUM_MAINNET = "arbitrum:mainnet"


GenericVisualizePortfolioBlockTypedDict = TypeAliasType(
    "GenericVisualizePortfolioBlockTypedDict", Union[int, str]
)
r"""The block number you want to get this data at."""


GenericVisualizePortfolioBlock = TypeAliasType(
    "GenericVisualizePortfolioBlock", Union[int, str]
)
r"""The block number you want to get this data at."""


class GenericVisualizePortfolioRequestTypedDict(TypedDict):
    chain: GenericVisualizePortfolioChain
    r"""The chain to use."""
    block: NotRequired[GenericVisualizePortfolioBlockTypedDict]
    r"""The block number you want to get this data at."""
    user: NotRequired[str]
    r"""The user to get portfolio for."""


class GenericVisualizePortfolioRequest(BaseModel):
    chain: Annotated[
        GenericVisualizePortfolioChain,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = GenericVisualizePortfolioChain.ARBITRUM_MAINNET
    r"""The chain to use."""

    block: Annotated[
        Optional[GenericVisualizePortfolioBlock],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""The block number you want to get this data at."""

    user: Annotated[
        Optional[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = "0x29F20a192328eF1aD35e1564aBFf4Be9C5ce5f7B"
    r"""The user to get portfolio for."""
