"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from typing import Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


class MorphoMarketPositionChain(str, Enum):
    ETHEREUM_MAINNET = "ethereum:mainnet"
    BASE_MAINNET = "base:mainnet"


MorphoMarketPositionBlockTypedDict = TypeAliasType(
    "MorphoMarketPositionBlockTypedDict", Union[int, str]
)
r"""The block number you want to get this data at."""


MorphoMarketPositionBlock = TypeAliasType("MorphoMarketPositionBlock", Union[int, str])
r"""The block number you want to get this data at."""


class MorphoMarketPositionRequestTypedDict(TypedDict):
    chain: MorphoMarketPositionChain
    block: NotRequired[MorphoMarketPositionBlockTypedDict]
    r"""The block number you want to get this data at."""
    user_address: str
    r"""The user address of the desired market position."""
    unique_market_key: str
    r"""The key that uniquely identifies the market. This can be found using the 'Get Markets' endpoint."""


class MorphoMarketPositionRequest(BaseModel):
    chain: Annotated[
        MorphoMarketPositionChain,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = MorphoMarketPositionChain.ETHEREUM_MAINNET

    block: Annotated[
        Optional[MorphoMarketPositionBlock],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""The block number you want to get this data at."""

    user_address: Annotated[
        str, FieldMetadata(query=QueryParamMetadata(style="form", explode=True))
    ] = "0xa829B388A3DF7f581cE957a95edbe419dd146d1B"
    r"""The user address of the desired market position."""

    unique_market_key: Annotated[
        str, FieldMetadata(query=QueryParamMetadata(style="form", explode=True))
    ] = "0xe7399fdebc318d76dfec7356caafcf8cd4b91287e139a3ec423f09aeeb656fc4"
    r"""The key that uniquely identifies the market. This can be found using the 'Get Markets' endpoint."""
