"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from typing import Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


class MorphoVaultChain(str, Enum):
    ETHEREUM_MAINNET = "ethereum:mainnet"
    BASE_MAINNET = "base:mainnet"


MorphoVaultBlockTypedDict = TypeAliasType("MorphoVaultBlockTypedDict", Union[int, str])
r"""The block number you want to get this data at."""


MorphoVaultBlock = TypeAliasType("MorphoVaultBlock", Union[int, str])
r"""The block number you want to get this data at."""


class MorphoVaultRequestTypedDict(TypedDict):
    chain: MorphoVaultChain
    block: NotRequired[MorphoVaultBlockTypedDict]
    r"""The block number you want to get this data at."""
    vault_address: str
    r"""The vault address of the desired vault data & metrics."""


class MorphoVaultRequest(BaseModel):
    chain: Annotated[
        MorphoVaultChain,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = MorphoVaultChain.ETHEREUM_MAINNET

    block: Annotated[
        Optional[MorphoVaultBlock],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""The block number you want to get this data at."""

    vault_address: Annotated[
        str, FieldMetadata(query=QueryParamMetadata(style="form", explode=True))
    ] = "0xbEef047a543E45807105E51A8BBEFCc5950fcfBa"
    r"""The vault address of the desired vault data & metrics."""
