"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import FieldMetadata, QueryParamMetadata, validate_const
import pydantic
from pydantic.functional_validators import AfterValidator
from typing import Literal, Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


SkyPositionBlockTypedDict = TypeAliasType("SkyPositionBlockTypedDict", Union[int, str])
r"""The block number you want to get this data at."""


SkyPositionBlock = TypeAliasType("SkyPositionBlock", Union[int, str])
r"""The block number you want to get this data at."""


class SkyPositionRequestTypedDict(TypedDict):
    chain: Literal["ethereum:mainnet"]
    block: NotRequired[SkyPositionBlockTypedDict]
    r"""The block number you want to get this data at."""
    user_address: str
    r"""The user address of the desired position."""


class SkyPositionRequest(BaseModel):
    CHAIN: Annotated[
        Annotated[
            Optional[Literal["ethereum:mainnet"]],
            AfterValidator(validate_const("ethereum:mainnet")),
        ],
        pydantic.Field(alias="chain"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = "ethereum:mainnet"

    block: Annotated[
        Optional[SkyPositionBlock],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""The block number you want to get this data at."""

    user_address: Annotated[
        str, FieldMetadata(query=QueryParamMetadata(style="form", explode=True))
    ] = "0xa829B388A3DF7f581cE957a95edbe419dd146d1B"
    r"""The user address of the desired position."""
