"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from typing import Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


class UniswapLiquidityProvisionInRangeChain(str, Enum):
    r"""The chain to use."""

    BASE_MAINNET = "base:mainnet"
    ETHEREUM_MAINNET = "ethereum:mainnet"
    ARBITRUM_MAINNET = "arbitrum:mainnet"


UniswapLiquidityProvisionInRangeBlockTypedDict = TypeAliasType(
    "UniswapLiquidityProvisionInRangeBlockTypedDict", Union[int, str]
)
r"""The block number you want to get this data at."""


UniswapLiquidityProvisionInRangeBlock = TypeAliasType(
    "UniswapLiquidityProvisionInRangeBlock", Union[int, str]
)
r"""The block number you want to get this data at."""


class UniswapLiquidityProvisionInRangeRequestTypedDict(TypedDict):
    chain: UniswapLiquidityProvisionInRangeChain
    r"""The chain to use."""
    block: NotRequired[UniswapLiquidityProvisionInRangeBlockTypedDict]
    r"""The block number you want to get this data at."""
    token_id: int
    r"""Token ID of the NFT representing the liquidity provisioned position."""


class UniswapLiquidityProvisionInRangeRequest(BaseModel):
    chain: Annotated[
        UniswapLiquidityProvisionInRangeChain,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = UniswapLiquidityProvisionInRangeChain.ARBITRUM_MAINNET
    r"""The chain to use."""

    block: Annotated[
        Optional[UniswapLiquidityProvisionInRangeBlock],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""The block number you want to get this data at."""

    token_id: Annotated[
        int, FieldMetadata(query=QueryParamMetadata(style="form", explode=True))
    ] = 4318185
    r"""Token ID of the NFT representing the liquidity provisioned position."""
